/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

static struct {
        uint32_t reg_address_hi;
        uint32_t reg_address_lo;
        uint32_t reg_tmp;

        uint32_t regs_to_dump[128];
        uint32_t regs_count;
} meta_print_data;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create_at_end(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("u8_32", *type, 5)) {
		*type += 5;
		return TYPE_U8_32;
	} else if (!strncmp("u64", *type, 3)) {
		*type += 3;
		return TYPE_ATOMIC_U64;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state_mut(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_buf_init_val(uint32_t val)
{
	assert(info->num_bufs > 0);
	unsigned idx = info->num_bufs - 1;

	if (!info->buf_init_data[idx]) {
		unsigned sz = info->buf_sizes[idx] * 4;
		info->buf_init_data[idx] = malloc(sz);
		memset(info->buf_init_data[idx], 0, sz);
	}

	assert(info->buf_init_data_sizes[idx] < info->buf_sizes[idx]);
	info->buf_init_data[idx][info->buf_init_data_sizes[idx]++] = val;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 366 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_LAST = 25,                    /* T_LAST  */
  YYSYMBOL_T_HR = 26,                      /* T_HR  */
  YYSYMBOL_T_HC = 27,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 28,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 29,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 30,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 31,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 32,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 33,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 34,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 35,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 36,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 37,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 38,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 39,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 40,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 41,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 42,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 43,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 44,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 45,                      /* T_SY  */
  YYSYMBOL_T_SS = 46,                      /* T_SS  */
  YYSYMBOL_T_JP = 47,                      /* T_JP  */
  YYSYMBOL_T_EQ_FLAG = 48,                 /* T_EQ_FLAG  */
  YYSYMBOL_T_SAT = 49,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 50,                     /* T_RPT  */
  YYSYMBOL_T_UL = 51,                      /* T_UL  */
  YYSYMBOL_T_NOP = 52,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 53,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 54,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 55,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 56,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 57,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 58,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 59,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 60,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 61,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 62,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 63,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 64,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 65,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 66,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 67,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 68,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 69,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 70,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 71,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 72,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 73,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 74,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 75,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 76,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 77,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 78,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 79,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 80,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 81,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 82,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 83,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 84,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 85,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 86,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 87,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 88,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 89,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 90,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 91,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 92,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 93,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 94,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 95,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 96,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 97,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 98,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 99,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 100,             /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 101,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 102,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 103,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 104,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 105,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 106,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 107,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 108,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 109,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 110,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 111,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 112,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 113,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 114,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 115,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 116,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 117,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 118,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 119,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 120,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 121,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 122,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 123,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 124,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 125,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 126,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 127,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 128,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 129,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 130,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 131,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 132,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 133,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 134,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 135,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 136,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 137,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 138,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 139,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 140,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 141,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 142,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 143,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 144,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 145,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 146,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 147,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 148,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 149,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 150,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 151,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 152,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 153,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 154,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 155,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 156,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 157,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 158,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 159,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 160,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 161,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 162,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 163,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 164,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 165,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 166,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 167,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 168,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 169,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 170,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 171,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 172,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 173,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 174,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 175,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 176,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 177,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 178,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 179,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 180,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 181,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 182,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 183,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 184,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 185,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 186,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 187,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 188,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 189,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 190,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 191,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 192,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 193,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 194,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 195,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 196,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 197,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 198,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 199,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 200,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 201,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 202,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 203,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 204,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 205,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 206,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 207,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 208,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 209,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDG_K = 210,               /* T_OP_LDG_K  */
  YYSYMBOL_T_OP_LDL = 211,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 212,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 213,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 214,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 215,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 216,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 217,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 218,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 219,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 220,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 221,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 222,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 223,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 224,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 225,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 226,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 227,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 228,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 229,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 230,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 231,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 232,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 233,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 234,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 235,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 236,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 237,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 238,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 239,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 240,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 241,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 242,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 243,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 244,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 245,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 246,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 247,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 248,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 249,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 250,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 251,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 252,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 253,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 254,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 255,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 256,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 257,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 258,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 259,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 260,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 261,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 262,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 263,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 264,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 265,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 266,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 267,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 268,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 269,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 270,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 271,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 272,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 273,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 274,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 275,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 276,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 277,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 278,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 279,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 280,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 281,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_SHFL = 282,                /* T_OP_SHFL  */
  YYSYMBOL_T_OP_BAR = 283,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 284,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 285,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 286,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 287,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 288,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 289,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_CCINV = 290,               /* T_OP_CCINV  */
  YYSYMBOL_T_OP_LOCK = 291,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 292,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 293,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 294,                    /* T_RAW  */
  YYSYMBOL_T_OP_PRINT = 295,               /* T_OP_PRINT  */
  YYSYMBOL_T_TYPE_F16 = 296,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 297,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 298,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 299,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 300,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 301,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 302,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_U8_32 = 303,             /* T_TYPE_U8_32  */
  YYSYMBOL_T_TYPE_U64 = 304,               /* T_TYPE_U64  */
  YYSYMBOL_T_UNTYPED = 305,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 306,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 307,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 308,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 309,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 310,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 311,                     /* T_1D  */
  YYSYMBOL_T_2D = 312,                     /* T_2D  */
  YYSYMBOL_T_3D = 313,                     /* T_3D  */
  YYSYMBOL_T_4D = 314,                     /* T_4D  */
  YYSYMBOL_T_LT = 315,                     /* T_LT  */
  YYSYMBOL_T_LE = 316,                     /* T_LE  */
  YYSYMBOL_T_GT = 317,                     /* T_GT  */
  YYSYMBOL_T_GE = 318,                     /* T_GE  */
  YYSYMBOL_T_EQ = 319,                     /* T_EQ  */
  YYSYMBOL_T_NE = 320,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 321,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 322,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 323,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 324,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 325,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 326,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 327,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 328,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 329,                    /* T_NAN  */
  YYSYMBOL_T_INF = 330,                    /* T_INF  */
  YYSYMBOL_T_A0 = 331,                     /* T_A0  */
  YYSYMBOL_T_A1 = 332,                     /* T_A1  */
  YYSYMBOL_T_P0 = 333,                     /* T_P0  */
  YYSYMBOL_T_W = 334,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 335,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 336,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 337,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 338,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 339,                 /* T_MOD_RT  */
  YYSYMBOL_T_MOD_XOR = 340,                /* T_MOD_XOR  */
  YYSYMBOL_T_MOD_UP = 341,                 /* T_MOD_UP  */
  YYSYMBOL_T_MOD_DOWN = 342,               /* T_MOD_DOWN  */
  YYSYMBOL_T_MOD_RUP = 343,                /* T_MOD_RUP  */
  YYSYMBOL_T_MOD_RDOWN = 344,              /* T_MOD_RDOWN  */
  YYSYMBOL_345_ = 345,                     /* '-'  */
  YYSYMBOL_346_ = 346,                     /* ','  */
  YYSYMBOL_347_ = 347,                     /* '('  */
  YYSYMBOL_348_ = 348,                     /* ')'  */
  YYSYMBOL_349_ = 349,                     /* '='  */
  YYSYMBOL_350_ = 350,                     /* ':'  */
  YYSYMBOL_351_ = 351,                     /* '!'  */
  YYSYMBOL_352_ = 352,                     /* '#'  */
  YYSYMBOL_353_ = 353,                     /* '.'  */
  YYSYMBOL_354_a_ = 354,                   /* 'a'  */
  YYSYMBOL_355_o_ = 355,                   /* 'o'  */
  YYSYMBOL_356_p_ = 356,                   /* 'p'  */
  YYSYMBOL_357_s_ = 357,                   /* 's'  */
  YYSYMBOL_358_v_ = 358,                   /* 'v'  */
  YYSYMBOL_359_ = 359,                     /* '+'  */
  YYSYMBOL_360_ = 360,                     /* '<'  */
  YYSYMBOL_361_g_ = 361,                   /* 'g'  */
  YYSYMBOL_362_ = 362,                     /* '['  */
  YYSYMBOL_363_ = 363,                     /* ']'  */
  YYSYMBOL_364_c_ = 364,                   /* 'c'  */
  YYSYMBOL_365_l_ = 365,                   /* 'l'  */
  YYSYMBOL_366_u_ = 366,                   /* 'u'  */
  YYSYMBOL_367_k_ = 367,                   /* 'k'  */
  YYSYMBOL_368_w_ = 368,                   /* 'w'  */
  YYSYMBOL_369_r_ = 369,                   /* 'r'  */
  YYSYMBOL_370_ = 370,                     /* '>'  */
  YYSYMBOL_371_h_ = 371,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 372,                 /* $accept  */
  YYSYMBOL_shader = 373,                   /* shader  */
  YYSYMBOL_374_1 = 374,                    /* $@1  */
  YYSYMBOL_headers = 375,                  /* headers  */
  YYSYMBOL_header = 376,                   /* header  */
  YYSYMBOL_const_val = 377,                /* const_val  */
  YYSYMBOL_localsize_header = 378,         /* localsize_header  */
  YYSYMBOL_const_header = 379,             /* const_header  */
  YYSYMBOL_buf_header_init_val = 380,      /* buf_header_init_val  */
  YYSYMBOL_buf_header_init_vals = 381,     /* buf_header_init_vals  */
  YYSYMBOL_buf_header_addr_reg = 382,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 383,               /* buf_header  */
  YYSYMBOL_384_2 = 384,                    /* $@2  */
  YYSYMBOL_invocationid_header = 385,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 386,              /* wgid_header  */
  YYSYMBOL_numwg_header = 387,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 388,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 389,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 390,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 391,                /* in_header  */
  YYSYMBOL_out_header = 392,               /* out_header  */
  YYSYMBOL_tex_header = 393,               /* tex_header  */
  YYSYMBOL_iflag = 394,                    /* iflag  */
  YYSYMBOL_iflags = 395,                   /* iflags  */
  YYSYMBOL_instrs = 396,                   /* instrs  */
  YYSYMBOL_instr = 397,                    /* instr  */
  YYSYMBOL_label = 398,                    /* label  */
  YYSYMBOL_cat0_src1 = 399,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 400,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 401,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 402,               /* cat0_instr  */
  YYSYMBOL_403_3 = 403,                    /* $@3  */
  YYSYMBOL_404_4 = 404,                    /* $@4  */
  YYSYMBOL_405_5 = 405,                    /* $@5  */
  YYSYMBOL_406_6 = 406,                    /* $@6  */
  YYSYMBOL_407_7 = 407,                    /* $@7  */
  YYSYMBOL_408_8 = 408,                    /* $@8  */
  YYSYMBOL_409_9 = 409,                    /* $@9  */
  YYSYMBOL_410_10 = 410,                   /* $@10  */
  YYSYMBOL_411_11 = 411,                   /* $@11  */
  YYSYMBOL_412_12 = 412,                   /* $@12  */
  YYSYMBOL_413_13 = 413,                   /* $@13  */
  YYSYMBOL_414_14 = 414,                   /* $@14  */
  YYSYMBOL_415_15 = 415,                   /* $@15  */
  YYSYMBOL_416_16 = 416,                   /* $@16  */
  YYSYMBOL_cat1_opc = 417,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 418,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 419,              /* cat1_movmsk  */
  YYSYMBOL_420_17 = 420,                   /* $@17  */
  YYSYMBOL_mova_src = 421,                 /* mova_src  */
  YYSYMBOL_cat1_mova1 = 422,               /* cat1_mova1  */
  YYSYMBOL_423_18 = 423,                   /* $@18  */
  YYSYMBOL_cat1_mova = 424,                /* cat1_mova  */
  YYSYMBOL_425_19 = 425,                   /* $@19  */
  YYSYMBOL_cat1_swz = 426,                 /* cat1_swz  */
  YYSYMBOL_427_20 = 427,                   /* $@20  */
  YYSYMBOL_cat1_gat = 428,                 /* cat1_gat  */
  YYSYMBOL_429_21 = 429,                   /* $@21  */
  YYSYMBOL_cat1_sct = 430,                 /* cat1_sct  */
  YYSYMBOL_431_22 = 431,                   /* $@22  */
  YYSYMBOL_cat1_instr = 432,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 433,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 434,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 435,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 436,                     /* cond  */
  YYSYMBOL_cat2_instr = 437,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 438,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 439,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 440,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 441,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 442,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 443,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 444,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 445,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 446,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 447,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc_isam = 448,            /* cat5_opc_isam  */
  YYSYMBOL_cat5_opc = 449,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 450,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 451,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 452,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 453,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 454,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 455,                  /* cat5_a1  */
  YYSYMBOL_cat5_samp_tex = 456,            /* cat5_samp_tex  */
  YYSYMBOL_cat5_samp_tex_all = 457,        /* cat5_samp_tex_all  */
  YYSYMBOL_cat5_instr = 458,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 459,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 460,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 461,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 462,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 463,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 464,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 465,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 466, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 467, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 468, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 469,                /* cat6_load  */
  YYSYMBOL_470_23 = 470,                   /* $@23  */
  YYSYMBOL_471_24 = 471,                   /* $@24  */
  YYSYMBOL_472_25 = 472,                   /* $@25  */
  YYSYMBOL_473_26 = 473,                   /* $@26  */
  YYSYMBOL_474_27 = 474,                   /* $@27  */
  YYSYMBOL_475_28 = 475,                   /* $@28  */
  YYSYMBOL_476_29 = 476,                   /* $@29  */
  YYSYMBOL_477_30 = 477,                   /* $@30  */
  YYSYMBOL_cat6_store = 478,               /* cat6_store  */
  YYSYMBOL_479_31 = 479,                   /* $@31  */
  YYSYMBOL_480_32 = 480,                   /* $@32  */
  YYSYMBOL_481_33 = 481,                   /* $@33  */
  YYSYMBOL_482_34 = 482,                   /* $@34  */
  YYSYMBOL_483_35 = 483,                   /* $@35  */
  YYSYMBOL_cat6_loadib = 484,              /* cat6_loadib  */
  YYSYMBOL_485_36 = 485,                   /* $@36  */
  YYSYMBOL_cat6_storeib = 486,             /* cat6_storeib  */
  YYSYMBOL_487_37 = 487,                   /* $@37  */
  YYSYMBOL_cat6_prefetch = 488,            /* cat6_prefetch  */
  YYSYMBOL_489_38 = 489,                   /* $@38  */
  YYSYMBOL_cat6_atomic_opc = 490,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 491,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 492,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 493,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 494,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 495,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 496,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 497,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 498,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 499,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 500,                 /* cat6_ibo  */
  YYSYMBOL_501_39 = 501,                   /* $@39  */
  YYSYMBOL_cat6_id_opc = 502,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 503,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 504,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 505,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 506,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 507, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 508, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_3src = 509, /* cat6_bindless_ibo_opc_3src  */
  YYSYMBOL_cat6_bindless_ibo_opc_3src_dst = 510, /* cat6_bindless_ibo_opc_3src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 511,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 512,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 513, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 514,        /* cat6_bindless_ldc  */
  YYSYMBOL_const_dst = 515,                /* const_dst  */
  YYSYMBOL_cat6_stc = 516,                 /* cat6_stc  */
  YYSYMBOL_517_40 = 517,                   /* $@40  */
  YYSYMBOL_518_41 = 518,                   /* $@41  */
  YYSYMBOL_cat6_shfl_mode = 519,           /* cat6_shfl_mode  */
  YYSYMBOL_cat6_shfl = 520,                /* cat6_shfl  */
  YYSYMBOL_521_42 = 521,                   /* $@42  */
  YYSYMBOL_cat6_todo = 522,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 523,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 524,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 525,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 526,             /* cat7_barrier  */
  YYSYMBOL_527_43 = 527,                   /* $@43  */
  YYSYMBOL_528_44 = 528,                   /* $@44  */
  YYSYMBOL_cat7_data_cache = 529,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 530,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 531,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 532,               /* cat7_instr  */
  YYSYMBOL_533_45 = 533,                   /* $@45  */
  YYSYMBOL_raw_instr = 534,                /* raw_instr  */
  YYSYMBOL_meta_print_regs = 535,          /* meta_print_regs  */
  YYSYMBOL_meta_print_reg = 536,           /* meta_print_reg  */
  YYSYMBOL_meta_print_start = 537,         /* meta_print_start  */
  YYSYMBOL_meta_print = 538,               /* meta_print  */
  YYSYMBOL_src = 539,                      /* src  */
  YYSYMBOL_dst = 540,                      /* dst  */
  YYSYMBOL_const = 541,                    /* const  */
  YYSYMBOL_dst_reg_flag = 542,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 543,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 544,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 545,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 546,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 547,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 548,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 549,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 550,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 551,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 552, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 553,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_uoffset = 554,                  /* uoffset  */
  YYSYMBOL_offset = 555,                   /* offset  */
  YYSYMBOL_src_uoffset = 556,              /* src_uoffset  */
  YYSYMBOL_relative_gpr_src = 557,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 558,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 559,           /* relative_const  */
  YYSYMBOL_relative = 560,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 561,           /* immediate_cat1  */
  YYSYMBOL_immediate = 562,                /* immediate  */
  YYSYMBOL_flut_immed = 563,               /* flut_immed  */
  YYSYMBOL_integer = 564,                  /* integer  */
  YYSYMBOL_float = 565,                    /* float  */
  YYSYMBOL_type = 566                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 335 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 977 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1602

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  372
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  195
/* YYNRULES -- Number of rules.  */
#define YYNRULES  601
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1280

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   599


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   351,     2,   352,     2,     2,     2,     2,
     347,   348,     2,   359,   346,   345,   353,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   350,     2,
     360,   349,   370,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   362,     2,   363,     2,     2,     2,   354,     2,   364,
       2,     2,     2,   361,   371,     2,     2,   367,   365,     2,
       2,   355,   356,     2,   369,   357,     2,   366,   358,   368,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   748,   748,   748,   750,   751,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   766,   767,
     768,   769,   771,   777,   781,   782,   783,   784,   787,   795,
     797,   797,   803,   809,   816,   823,   832,   834,   836,   839,
     841,   843,   850,   851,   852,   853,   854,   855,   856,   857,
     859,   860,   862,   863,   865,   866,   867,   868,   869,   870,
     871,   872,   873,   874,   875,   877,   879,   880,   882,   883,
     885,   886,   888,   889,   889,   890,   890,   891,   891,   892,
     892,   893,   893,   894,   894,   895,   895,   896,   896,   897,
     897,   898,   899,   899,   900,   901,   902,   903,   904,   905,
     906,   906,   907,   908,   909,   910,   911,   911,   912,   913,
     913,   914,   915,   916,   917,   918,   918,   920,   923,   927,
     928,   930,   930,   946,   947,   948,   950,   950,   957,   957,
     964,   964,   966,   966,   968,   968,   971,   972,   973,   974,
     975,   976,   977,   978,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   995,   996,
     997,   998,   999,  1000,  1002,  1003,  1004,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1030,  1031,  1032,  1033,  1034,  1035,  1037,  1038,  1039,
    1041,  1042,  1044,  1045,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,
    1064,  1065,  1066,  1067,  1068,  1070,  1071,  1073,  1074,  1076,
    1077,  1078,  1079,  1081,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,  1089,  1090,  1092,  1094,  1095,  1097,  1099,  1100,  1101,
    1102,  1103,  1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1122,  1123,  1124,  1125,  1126,  1127,  1128,  1130,  1131,  1132,
    1133,  1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,  1142,
    1144,  1145,  1146,  1147,  1149,  1150,  1151,  1152,  1154,  1155,
    1156,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1166,
    1168,  1169,  1171,  1172,  1173,  1174,  1176,  1177,  1178,  1179,
    1180,  1181,  1183,  1186,  1191,  1197,  1203,  1206,  1208,  1208,
    1209,  1209,  1210,  1210,  1211,  1211,  1212,  1212,  1213,  1213,
    1214,  1214,  1214,  1218,  1218,  1219,  1219,  1220,  1220,  1221,
    1221,  1222,  1222,  1224,  1224,  1225,  1225,  1227,  1227,  1229,
    1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,
    1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,
    1251,  1253,  1254,  1255,  1256,  1257,  1258,  1259,  1260,  1261,
    1262,  1263,  1265,  1267,  1269,  1271,  1272,  1273,  1275,  1277,
    1278,  1280,  1281,  1282,  1282,  1285,  1286,  1287,  1289,  1291,
    1292,  1294,  1295,  1296,  1298,  1299,  1301,  1303,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,  1315,  1317,
    1319,  1320,  1321,  1322,  1324,  1328,  1329,  1330,  1332,  1338,
    1339,  1340,  1343,  1343,  1344,  1344,  1346,  1347,  1348,  1349,
    1350,  1354,  1357,  1357,  1360,  1361,  1362,  1364,  1365,  1366,
    1367,  1368,  1369,  1370,  1371,  1372,  1373,  1374,  1375,  1376,
    1378,  1379,  1380,  1381,  1383,  1384,  1386,  1386,  1387,  1387,
    1389,  1390,  1391,  1393,  1394,  1396,  1397,  1398,  1400,  1401,
    1402,  1403,  1404,  1405,  1406,  1407,  1407,  1414,  1416,  1417,
    1419,  1423,  1430,  1488,  1489,  1490,  1491,  1493,  1494,  1495,
    1496,  1498,  1500,  1501,  1502,  1503,  1504,  1506,  1507,  1510,
    1511,  1513,  1514,  1515,  1516,  1517,  1519,  1520,  1522,  1523,
    1525,  1526,  1528,  1529,  1531,  1532,  1534,  1535,  1536,  1538,
    1539,  1540,  1542,  1543,  1544,  1546,  1547,  1549,  1550,  1552,
    1554,  1555,  1557,  1558,  1560,  1561,  1563,  1564,  1573,  1574,
    1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,
    1586,  1587,  1588,  1589,  1590,  1593,  1594,  1595,  1596,  1597,
    1598,  1599,  1600,  1601,  1602,  1603,  1604,  1606,  1607,  1608,
    1609,  1611,  1612,  1614,  1615,  1616,  1617,  1618,  1619,  1620,
    1621,  1622
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_LAST",
  "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_EQ_FLAG", "T_SAT", "T_RPT", "T_UL", "T_NOP",
  "T_OP_NOP", "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC",
  "T_OP_BANY", "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL",
  "T_OP_RET", "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT",
  "T_OP_CHMASK", "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS",
  "T_OP_STKR", "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE",
  "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF",
  "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV",
  "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDG_K", "T_OP_LDL", "T_OP_LDP", "T_OP_STG",
  "T_OP_STG_A", "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L",
  "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT",
  "T_OP_RESINFO", "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_SHFL", "T_OP_BAR", "T_OP_FENCE",
  "T_OP_SLEEP", "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU",
  "T_OP_CCINV", "T_OP_LOCK", "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW",
  "T_OP_PRINT", "T_TYPE_F16", "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32",
  "T_TYPE_S16", "T_TYPE_S32", "T_TYPE_U8", "T_TYPE_U8_32", "T_TYPE_U64",
  "T_UNTYPED", "T_TYPED", "T_MIXED", "T_UNSIGNED", "T_LOW", "T_HIGH",
  "T_1D", "T_2D", "T_3D", "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ",
  "T_NE", "T_S2EN", "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM",
  "T_NONUNIFORM", "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX", "T_MOD_MEM", "T_MOD_RT",
  "T_MOD_XOR", "T_MOD_UP", "T_MOD_DOWN", "T_MOD_RUP", "T_MOD_RDOWN", "'-'",
  "','", "'('", "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'", "'o'",
  "'p'", "'s'", "'v'", "'+'", "'<'", "'g'", "'['", "']'", "'c'", "'l'",
  "'u'", "'k'", "'w'", "'r'", "'>'", "'h'", "$accept", "shader", "$@1",
  "headers", "header", "const_val", "localsize_header", "const_header",
  "buf_header_init_val", "buf_header_init_vals", "buf_header_addr_reg",
  "buf_header", "$@2", "invocationid_header", "wgid_header",
  "numwg_header", "branchstack_header", "pvtmem_header",
  "earlypreamble_header", "in_header", "out_header", "tex_header", "iflag",
  "iflags", "instrs", "instr", "label", "cat0_src1", "cat0_src2",
  "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16",
  "cat1_opc", "cat1_src", "cat1_movmsk", "$@17", "mova_src", "cat1_mova1",
  "$@18", "cat1_mova", "$@19", "cat1_swz", "$@20", "cat1_gat", "$@21",
  "cat1_sct", "$@22", "cat1_instr", "cat2_opc_1src", "cat2_opc_2src_cnd",
  "cat2_opc_2src", "cond", "cat2_instr", "cat3_dp_signedness",
  "cat3_dp_pack", "cat3_opc", "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp",
  "cat3_instr", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp",
  "cat5_opc_isam", "cat5_opc", "cat5_flag", "cat5_flags", "cat5_samp",
  "cat5_tex", "cat5_type", "cat5_a1", "cat5_samp_tex", "cat5_samp_tex_all",
  "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset",
  "cat6_offset", "cat6_dst_offset", "cat6_immed",
  "cat6_a6xx_global_address_pt3", "cat6_a6xx_global_address_pt2",
  "cat6_a6xx_global_address", "cat6_load", "$@23", "$@24", "$@25", "$@26",
  "$@27", "$@28", "$@29", "$@30", "cat6_store", "$@31", "$@32", "$@33",
  "$@34", "$@35", "cat6_loadib", "$@36", "cat6_storeib", "$@37",
  "cat6_prefetch", "$@38", "cat6_atomic_opc", "cat6_a3xx_atomic_opc",
  "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s", "cat6_a6xx_atomic_g",
  "cat6_atomic_l", "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@39", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_3src", "cat6_bindless_ibo_opc_3src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle",
  "cat6_bindless_ldc", "const_dst", "cat6_stc", "$@40", "$@41",
  "cat6_shfl_mode", "cat6_shfl", "$@42", "cat6_todo", "cat6_instr",
  "cat7_scope", "cat7_scopes", "cat7_barrier", "$@43", "$@44",
  "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope", "cat7_instr",
  "$@45", "raw_instr", "meta_print_regs", "meta_print_reg",
  "meta_print_start", "meta_print", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "uoffset", "offset", "src_uoffset",
  "relative_gpr_src", "relative_gpr_dst", "relative_const", "relative",
  "immediate_cat1", "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-942)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -942,    59,  1259,  -942,    53,  -284,    53,  -268,  -261,  -229,
      53,  -221,  -207,  -204,    53,  -942,  1051,  1259,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,   100,  -200,   183,  -942,   158,   130,   186,
    -942,   190,   193,   201,  -942,  -139,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,   215,   238,  1309,   727,  -942,
    -942,  -942,  -121,  -942,  -942,  -942,    53,  -113,  -120,  -108,
     -96,   -78,   -76,   -71,   -48,   -46,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,   -49,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,   -44,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
     -38,   -27,   -17,   -29,   -12,   -11,   -10,    -8,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,    99,  -942,  -942,  -942,  -942,  -942,  -942,  -942,   388,
      -3,   388,  -942,   388,   388,   388,    -2,  -942,   388,  -942,
      -1,     0,    -1,  -942,  -942,  -942,  -942,  -942,  -942,     2,
       2,     2,  -942,  -942,  -942,  -942,     3,     2,     2,  -942,
       3,  -942,     2,     2,     2,     2,  -942,     7,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,   319,  -942,  -121,
      16,    53,   355,    53,  -942,  -942,  -942,  -942,   359,   360,
     362,  -246,  -246,  -246,   145,  -246,  -246,    17,    17,    17,
    -246,    17,    41,    17,    17,    42,    32,    36,    45,    49,
      51,    58,    62,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,    33,     3,     3,     2,     3,     3,     3,
      46,    47,    47,    50,  -942,    44,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,    48,  -942,   301,   105,    56,    60,
      61,   250,    65,    66,    69,    78,  -157,    70,    79,   389,
      -1,   388,   972,    80,    80,  -150,    86,    86,    86,   351,
      86,    86,    86,   388,    86,    86,    86,    86,    19,  -942,
    -942,    53,    87,   103,  -942,   101,  -942,   114,   115,   118,
    -942,   137,   125,   128,   146,  -942,  -942,   157,  -942,   148,
     150,    38,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,   388,   388,
     112,   388,   388,   138,   143,   126,   152,    86,   156,   388,
     144,    86,   388,   161,   164,   141,  -135,    47,  -942,  -942,
    -149,   179,   181,  -942,  -942,   313,   313,   777,  -942,  -942,
    -942,  -942,  -942,  -942,   388,   777,   191,   920,   147,  -942,
    -942,  -134,   388,   777,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,   173,    -1,   351,   388,
     388,  -942,  -942,  -190,     3,     3,     3,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,   388,     3,     3,
    -942,     3,     3,     3,     3,   168,   187,   189,   198,  -942,
    -942,    53,  -942,    53,   540,   541,   145,  -942,    17,  -244,
    -244,  -942,  -942,    17,    17,    17,  -942,  -942,    17,   388,
     313,   313,   388,   388,   388,   202,   205,   192,   206,   210,
     196,   213,   214,   217,     3,   174,   231,   218,     3,   235,
     220,   221,  -942,  -942,  -942,  -942,  -942,     3,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,   232,  -257,  -257,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,   226,   228,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,    29,   234,   239,
     248,  -942,  -942,  -942,   513,    57,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,   145,   628,
     969,  -942,  -942,  -942,  -942,  -942,   254,   255,   256,   174,
    -942,   259,  -942,  -942,  -942,   270,  -942,  -942,  -942,   271,
    -942,   597,    80,   276,   279,   280,  -942,  -942,  -942,  -942,
     275,   288,   290,   283,   304,   306,   320,   321,   323,   325,
     145,   354,   316,   113,   334,  -942,   337,   338,   346,  -942,
    -942,   361,   347,   349,  -942,  -942,  -942,  -942,  -942,  -942,
     990,  -942,  -942,  -942,   350,   352,   353,   336,   342,   155,
     340,   356,   174,   589,   174,   174,   358,  -250,   341,   174,
     364,   343,   155,   155,   105,   371,   145,   145,  -942,   344,
     365,   391,   394,  -942,   378,   383,   216,   384,   390,   405,
     409,    77,  -942,  -942,  -942,  -942,   401,   145,  -942,  -942,
     777,   777,   589,   589,   597,   920,  -942,   388,  -942,   597,
     240,   145,   145,   145,   381,   145,   145,   145,   145,   145,
     145,   398,   399,   404,   408,  -942,  -942,    53,   145,   145,
     752,  -942,    17,    17,  -942,   388,   597,   388,   397,   406,
     402,   400,  -942,   407,   420,  -257,   423,    40,   411,  -226,
    -226,   145,   113,  -942,   424,  -942,   421,  -226,   145,   426,
     427,   429,   425,   436,  -942,  -942,  -942,  -942,  -257,  -257,
    -942,  -942,  -942,  -942,  -942,  -257,  -257,   445,   446,  -942,
     447,   451,  -942,   459,   461,   462,   463,   476,   479,  -942,
    -942,   480,  -942,  -942,   481,   477,   483,   484,   467,   388,
    -942,   489,   491,   494,   495,   -60,   145,   -60,   113,   486,
     485,   501,   502,  -942,  -942,   488,   506,   509,   174,   589,
     145,   511,   174,   174,   498,   512,   170,   113,   499,  -942,
     503,   388,  -942,   519,   174,   504,   493,   145,   523,   524,
     174,   145,   505,   515,   516,   517,  -942,  -942,  -942,   777,
     191,   920,    34,   589,   597,   240,   548,   240,   507,   521,
     522,   113,   528,   527,   -60,   -60,   -60,   -60,   542,   542,
     542,   388,   543,   529,  -942,    53,  -942,  -942,   145,   597,
     597,   388,  -250,   531,  -942,   536,  -250,  -250,   530,   174,
     174,  -942,  -111,  -942,   552,   555,   556,   145,  -250,   557,
     544,   545,   597,    34,   558,   388,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,   559,   551,   561,   565,  -942,  -942,
     566,  -942,  -942,   569,   388,   388,   388,   553,   571,   572,
     388,   597,   597,   388,   595,  -942,  -942,  -942,  -942,   -60,
     573,  -942,   587,   590,   591,   592,   576,   594,   586,   588,
     602,   174,   603,  -257,   113,   606,  -942,   174,   174,   607,
    -942,   604,   174,    34,  -942,   623,   624,   113,   625,   920,
    -942,   632,   508,   597,   240,   240,   633,   636,   637,  -942,
     612,   113,   638,   639,   640,   641,  -942,   388,   618,   982,
     597,   597,   388,   643,    34,   174,   644,   645,   646,    34,
     651,  -942,   145,   654,   668,   653,   672,   681,   665,   683,
     145,   145,  -942,   856,  -942,   240,  -942,  -942,  -942,  -942,
    -942,  -942,   666,   669,   174,   113,   670,   113,   113,   113,
     113,  -942,   673,   686,  -942,   691,   692,    34,  -942,  -250,
      34,    34,    34,  -942,   679,  -257,    34,    34,    34,    34,
      34,   694,    34,  -942,  -942,  -942,  -942,  -942,  -942,   682,
     685,   695,   680,   705,  -942,   706,   551,   551,  -942,   145,
     597,   597,  -942,   687,  -942,  -942,  -942,   696,   699,  -942,
    -942,   697,  -942,  -942,   174,  -942,   113,   113,   174,   717,
     174,   113,   718,   719,   724,  -942,  -942,   725,   145,   722,
     737,   745,   741,   742,  -942,   174,   760,  -942,   113,   113,
    1101,    34,  -942,   145,   174,   174,   765,   766,   767,   113,
    -942,  -942,   768,  -942,  -942,   779,   781,   174,   174,   174,
     782,   145,   174,   174,  -942,   783,  -942,   174,   785,  -942,
    -942,   174,  -942,  1108,   786,   774,   174,   145,  -942,  -942
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    38,    50,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    30,     0,     0,     0,
      36,     0,     0,     0,    37,     0,    42,    43,    44,    45,
      46,    47,    48,    49,   497,     0,    50,     0,    50,    53,
      64,    62,     0,    63,     5,    20,     0,     0,    29,     0,
       0,     0,     0,     0,     0,     0,    65,   501,    51,    72,
      73,    75,    77,     0,    81,    83,    85,    87,    89,    91,
      92,    94,    95,    96,    97,    98,    99,   100,   102,   103,
     104,   105,     0,   106,   108,   109,   111,   112,   113,   114,
       0,     0,     0,     0,     0,     0,     0,     0,   164,   165,
     166,   167,   148,   158,   144,   161,   149,   150,   151,   152,
     153,   168,   169,   170,   171,   159,   160,   172,   173,   174,
     175,   145,   176,   177,   154,   178,   162,   163,   179,   180,
     181,   155,   147,   146,   182,   183,   184,   185,   186,   187,
     188,   156,   157,   189,   190,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   227,   228,   225,   226,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   244,   245,   270,   271,   272,   273,
     274,   275,   276,   309,   328,   330,   332,   336,   334,   343,
     345,   349,   347,   353,   454,   455,   357,   338,   351,   456,
     398,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   416,   429,   428,   417,   418,   419,   420,   421,
     422,   423,   424,   425,   426,   427,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   399,   400,
     355,   434,   340,   405,   406,   407,   442,   444,   452,   476,
     478,   490,   492,   480,   481,   482,   491,   493,   494,   495,
      54,     0,   136,   137,   138,   139,   140,   141,    55,     0,
       0,     0,    56,     0,     0,     0,     0,    57,     0,    58,
     288,   288,   288,    59,   457,   459,   458,   460,   461,     0,
       0,     0,   396,   397,   395,   462,     0,     0,     0,   463,
       0,   464,     0,     0,     0,     0,   466,     0,   465,   467,
     468,   469,    60,   488,   489,    61,    52,     0,   502,   498,
       0,     0,     0,    27,    32,    33,    34,    35,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   474,   474,     0,   507,     0,   512,   513,   514,   515,
     516,   508,   509,   510,     0,   519,   517,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     288,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   500,
     499,     0,     0,     0,    24,    25,    31,     0,     0,     0,
      67,     0,     0,     0,     0,   587,   589,     0,    79,     0,
       0,     0,    86,    88,    90,    93,   101,   115,   107,   110,
     121,   126,   128,   117,   118,   130,   132,   134,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   474,   477,   479,
       0,     0,     0,   518,   520,     0,     0,     0,   191,   192,
     193,   194,   195,   196,     0,     0,     0,     0,     0,   200,
     201,     0,     0,     0,   283,   277,   282,   286,   284,   285,
     287,   278,   279,   280,   281,   289,     0,   288,     0,     0,
       0,   310,   311,     0,     0,     0,     0,   593,   594,   595,
     596,   597,   598,   599,   600,   601,   316,     0,     0,     0,
     408,     0,     0,     0,     0,     0,     0,     0,     0,   322,
      22,     0,    28,    27,     0,     0,     0,    66,     0,     0,
       0,   588,   590,     0,     0,     0,    71,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   446,   447,   448,   449,   450,     0,   451,   473,
     472,   470,   471,   475,   485,   486,   487,     0,   545,   545,
     503,   511,   521,   522,   523,   524,   525,     0,     0,   565,
     566,   567,   568,   569,   504,   505,   506,     0,     0,     0,
       0,   142,   528,   532,   526,     0,   534,   535,   536,   119,
     556,   557,   537,   120,   558,   143,   575,   576,   577,   578,
     579,   580,   581,   582,   583,   584,   585,   586,     0,     0,
       0,   539,   197,   541,   572,   570,     0,     0,     0,     0,
     542,     0,   543,   544,   530,     0,   531,   202,   203,     0,
     243,     0,     0,     0,     0,   305,   312,   313,   314,   315,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    26,     0,     0,     0,    74,
      69,     0,     0,     0,    80,    82,    84,   116,   122,   127,
       0,   123,   124,   129,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   545,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   547,     0,
       0,     0,     0,   591,     0,     0,     0,     0,     0,     0,
       0,     0,   527,   529,   533,   538,     0,     0,   574,   540,
       0,     0,     0,     0,     0,     0,   301,     0,   292,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   414,   415,     0,     0,     0,
       0,    68,     0,     0,   125,     0,     0,     0,     0,     0,
     440,     0,   439,     0,     0,   545,     0,     0,     0,   545,
     545,     0,     0,   318,     0,   317,     0,   545,     0,     0,
       0,     0,     0,     0,   548,   546,   553,   552,   545,   545,
     563,   564,   592,   559,   560,   545,   545,     0,     0,   571,
       0,     0,   199,     0,     0,     0,     0,     0,     0,   290,
     291,   296,   297,   304,   294,     0,     0,     0,     0,     0,
     403,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,    78,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   320,
       0,     0,   319,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   561,   562,   573,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,   409,
     409,     0,     0,     0,   438,     0,    39,    40,     0,     0,
       0,     0,   545,     0,   441,     0,   545,   545,     0,     0,
       0,   327,     0,   321,     0,     0,     0,     0,   545,     0,
       0,     0,     0,     0,     0,     0,   551,   555,   554,   550,
     198,   229,   230,   231,     0,   545,   296,   297,   298,   307,
     294,   295,   303,   294,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   412,   413,   411,   435,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   545,     0,     0,   326,     0,     0,     0,
     358,     0,     0,     0,   341,     0,     0,     0,     0,     0,
     549,     0,     0,     0,     0,     0,     0,     0,     0,   401,
       0,     0,     0,     0,     0,     0,   410,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   324,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   453,     0,   232,     0,   299,   293,   300,   306,
     294,   302,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   436,     0,     0,   131,     0,     0,     0,   331,   545,
       0,     0,     0,   346,     0,   545,     0,     0,     0,     0,
       0,     0,     0,   443,   445,   496,   483,   484,   308,     0,
       0,     0,     0,     0,   430,     0,   545,   545,   437,     0,
       0,     0,   329,     0,   337,   335,   344,     0,     0,   350,
     348,     0,   339,   352,     0,   342,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   133,   135,     0,     0,     0,
       0,     0,     0,     0,   393,     0,     0,   431,     0,     0,
       0,     0,   325,     0,     0,     0,     0,     0,     0,     0,
     432,   433,     0,   333,   323,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   394,     0,   402,     0,     0,   354,
     356,     0,   404,     0,     0,     0,     0,     0,   392,    41
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -942,  -942,  -942,  1116,  -942,    -4,  -942,  -942,  -942,   525,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  1078,  -942,  1077,  -942,  -191,   520,  -349,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,   593,  -942,  -942,   514,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -281,
     296,  -801,  -449,    39,   297,  -921,  -942,   704,   690,   660,
     268,  -850,  -746,  -749,  -942,  -942,   195,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -740,  -751,   -65,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -522,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,  -401,  -942,  -942,  -942,  -942,  -942,  -942,
    -942,  -942,  -942,   770,  -942,  -942,  -942,   -39,  -443,  -667,
    -942,   701,  -326,  -942,  -520,  -512,  -942,  -942,  -742,  -516,
    -539,  -817,  -941,  -648,  -898,   596,  -942,  -942,  -538,  -617,
    -540,   431,  -393,   332,   577
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,   484,    18,    19,   485,   486,
     383,    20,    68,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    56,    57,    58,    59,    60,   492,   772,   502,
     320,   391,   392,   393,   623,   395,   396,   397,   398,   399,
     400,   401,   403,   404,   628,   321,   691,   322,   629,   779,
     323,   630,   324,   631,   325,   632,   326,   633,   327,   634,
     328,   329,   330,   331,   554,   332,   457,   562,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   460,   461,
    1046,  1047,   579,  1146,  1048,  1049,   343,   466,   584,   470,
     883,   884,   958,   607,  1086,  1021,   876,   344,   413,   414,
     415,   417,   416,   424,   427,  1139,   345,   418,   419,   421,
     420,   425,   346,   422,   347,   426,   348,   423,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   993,
     360,   361,  1065,  1001,   854,   362,   363,   364,   365,   366,
     367,   608,   368,   871,   369,   428,   429,   657,   370,   430,
     371,   372,   537,   538,   373,   431,   432,   374,  1185,   667,
     375,   433,    61,   378,   379,    62,    63,   692,   445,   693,
     446,   447,   448,   694,   729,   696,   735,   697,   698,   721,
     722,   731,   808,   885,  1101,   700,   449,   701,   702,   703,
     723,   724,   725,   818,   596
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      34,   498,    36,   450,   544,   452,    40,   453,   454,   455,
      44,   851,   458,   782,   782,   580,   727,   733,   916,   732,
     809,   810,   495,   496,   740,   695,   695,   720,   824,   699,
     699,   539,   495,   496,   813,   720,   695,   495,   496,   922,
     728,   495,   496,   720,   626,   730,   734,   670,   671,   503,
     504,   878,   506,   824,   508,   509,    30,    31,    32,     3,
     463,   464,   380,    35,   670,   671,  1052,   706,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,    37,
     495,   496,   813,   677,   678,   609,    38,   490,   806,   770,
     913,   914,   925,   926,   927,   806,   929,   930,   931,   932,
     933,   934,   807,    65,  1100,   491,   434,   771,   627,   882,
     780,   780,   434,   824,   781,   781,   495,   496,    39,   806,
     670,   746,   747,   748,   749,   435,    41,   436,   437,   438,
     439,   440,   961,   957,   960,   576,   663,    70,    71,   966,
      42,   965,   658,    43,   495,   496,    66,   600,   495,   496,
     559,   560,   704,   704,   670,   581,   582,   825,   495,   496,
     621,   622,  1076,   864,  1042,    69,  1079,  1080,   672,   673,
     674,   675,   676,   677,   822,   737,   738,   670,  1091,   575,
     829,   670,   825,  1149,  1151,  1051,  1003,  1002,   664,   665,
     666,    67,   635,   636,    72,   638,   639,    73,   670,   671,
      74,   493,   494,   646,   499,   500,   649,   878,    75,   505,
     824,    76,   672,   673,   674,   675,   676,   677,   678,   621,
     622,   902,    77,   768,  1188,   377,   659,   382,   726,   836,
     660,   959,   959,   661,   662,   381,   739,   704,   704,   959,
     384,  1044,   825,  1060,  1061,  1062,  1063,   670,  1084,  1085,
     972,   973,   385,   744,   745,  1100,  1100,   974,   975,  1066,
    1067,   672,   673,   674,   675,   676,   998,   999,  1000,   769,
     386,   753,   387,   877,   774,   775,   776,   388,  1090,   777,
     890,   891,  1144,    46,    47,    48,    49,    50,    51,    52,
      53,   911,   912,   837,   817,   733,   742,   732,  1222,  1223,
     389,  1051,   390,   778,   394,   406,   784,   785,   786,   402,
     720,   720,   877,   877,   407,   405,   495,   496,  1117,  1203,
     670,   671,   915,   730,   408,   826,   479,   918,   924,   436,
     437,   438,   439,   440,   672,   673,   674,   675,   676,   677,
     678,   409,   410,   411,   605,   412,   679,   680,   681,   682,
     451,   456,   459,   462,   946,   465,   469,   683,   814,   815,
     478,   892,   481,   483,   497,   487,   488,   609,   489,   501,
     856,   684,   685,   686,   816,   507,   510,   482,   511,   497,
     513,   718,   512,   497,   514,   606,   515,   704,   684,   685,
     686,  1183,  1184,   516,   528,   434,   872,   517,    33,   535,
     536,  1186,   545,   540,   541,   719,   546,   547,   542,   872,
     872,   555,   556,   894,   895,   557,   436,   437,   438,   439,
     440,   688,   816,   561,   558,   563,   689,   578,   907,   877,
     441,   442,   443,   611,   910,  1130,   441,   442,   443,   583,
    1040,   733,  1043,   732,   684,   685,   686,   613,   609,   609,
     609,   612,   609,   609,   609,   609,   609,   609,   497,   720,
     695,   614,   615,   877,  1041,   940,   941,   616,   444,   730,
     617,   618,  1045,  1050,   619,  1053,   637,   610,   684,   685,
     686,   652,   653,   654,   655,   656,   497,   870,   609,   895,
     497,   642,   620,  1096,   624,   609,   625,  1073,  1074,   640,
     497,   684,   685,   686,   641,   684,   685,   686,   643,   647,
     668,   917,   669,   943,   944,   670,   689,  1020,   645,   741,
    1095,   760,   684,   685,   686,   650,  1187,  1208,   651,   672,
     673,   674,   675,   676,   672,   673,   674,   675,   676,   945,
     761,   947,   762,   609,   763,   856,   766,   767,   787,  1113,
    1114,   788,   790,  1138,   789,   688,   791,  1014,   792,   733,
     689,   732,   919,   920,   895,   548,   549,   550,   551,   552,
     553,   684,   685,   686,  1031,   793,   794,   798,  1035,   795,
     799,   801,   802,   803,  1168,   805,   811,   730,   812,  1173,
    1147,  1147,  1150,  1150,   819,   821,   670,   671,   856,   820,
     830,   831,   832,   992,   670,   833,   797,   764,  1164,  1165,
     672,   673,   674,   675,   676,  1072,   834,   835,   672,   673,
     674,   675,   676,   877,   838,   839,   840,  1202,   841,   844,
    1204,  1205,  1206,  1150,   609,  1026,  1209,  1210,  1211,  1212,
    1213,   842,  1215,   843,   684,   685,   686,   587,   588,   589,
     590,   591,   592,   593,   594,   595,   823,   845,   497,   846,
     687,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   847,   848,  1068,   849,   688,   850,   852,
     857,   823,   689,   853,   690,  1075,   858,   859,  1225,  1226,
     823,   856,   860,   862,   861,   863,   865,   868,   866,   867,
     564,  1253,   565,   869,   856,   873,   886,   893,   889,  1098,
     566,   881,   874,   567,   896,   568,   569,   888,   856,   441,
     442,   443,   898,   570,   855,   899,   900,    -3,  1106,  1107,
    1108,   901,   903,    45,  1112,   897,   905,  1115,   904,  1175,
     906,   823,   928,   571,   572,   573,   574,   609,   609,   909,
     704,   935,   936,   875,   938,   879,   880,   937,   942,   948,
     887,   950,   856,   951,   856,   856,   856,   856,   949,   952,
     956,   970,    46,    47,    48,    49,    50,    51,    52,    53,
     495,   496,   953,   964,   670,   671,   955,   963,   967,   971,
     968,  1161,   969,   976,   977,   978,  1166,   979,   672,   673,
     674,   675,   676,   677,   678,   980,  1224,   981,   982,   983,
     706,   707,   708,   709,   710,   711,   712,   713,   714,   715,
     716,   717,   984,   856,   856,   985,   986,   987,   856,   991,
     988,   920,  1005,  1006,  1009,  1242,   989,   990,   823,   684,
     685,   686,   994,   962,   995,   856,   856,   996,   997,  1007,
    1254,  1008,  1010,   939,  1030,  1011,   856,  1015,  1019,   495,
     496,  1018,  1024,   670,   671,  1027,  1025,  1029,  1268,  1032,
    1033,   920,  1054,  1004,  1058,  1036,  1081,   672,   673,   674,
     675,   676,  1055,  1056,  1279,  1037,  1038,  1039,  1059,   679,
     680,   681,   682,  1070,  1077,  1064,  1069,  1078,  1087,   855,
     683,  1088,  1089,  1092,  1097,  1099,  1093,  1102,  1094,  1012,
     807,  1103,  1104,  1016,  1017,  1105,  1109,  1022,  1023,  1116,
     684,   685,   686,   495,   496,  1028,  1057,   670,   684,   685,
     686,  1034,  1110,  1119,  1111,  1118,  1120,  1121,  1122,  1123,
    1124,   672,   673,   674,   675,   676,   677,   678,  1125,  1129,
    1162,  1126,   855,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,  1127,  1132,  1136,  1135,  1140,
    1141,  1143,   495,   496,  1155,   827,   670,   671,  1145,  1152,
    1082,  1083,  1153,  1154,  1157,  1158,  1159,  1160,  1163,  1167,
    1170,  1171,  1172,   495,   496,   677,   678,   670,   671,  1174,
    1176,  1071,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   716,   717,  1177,  1178,   677,   678,  1179,  1131,
     473,    54,    55,   679,   680,   681,   682,  1180,  1181,  1182,
    1190,  1189,  1142,  1193,   683,  1199,  1198,  1200,  1201,  1207,
    1214,  1218,  1128,  1219,  1216,   855,  1156,  1217,  1133,  1134,
    1227,  1220,  1221,  1137,   467,   468,  1228,    45,   855,  1229,
    1230,   471,   472,  1235,  1238,  1239,   474,   475,   476,   477,
    1240,  1241,   855,   518,   519,   520,   521,   522,   523,   524,
     525,   526,  1243,  1244,   529,   530,  1169,   532,   533,   534,
    1192,  1245,  1194,  1195,  1196,  1197,    46,    47,    48,    49,
      50,    51,    52,    53,  1246,  1247,  1249,  1252,   684,   685,
     686,  1257,  1258,  1259,  1275,  1191,   855,  1261,   855,   855,
     855,   855,   497,  1277,   718,  1262,   527,  1263,  1267,  1271,
     531,  1273,  1276,    64,    78,   376,   921,   923,   765,   705,
     773,   688,  1148,   954,  1013,   783,   689,   543,   719,   480,
     828,  1232,  1233,   908,   736,   743,  1237,   585,   586,     0,
     597,   598,   599,     0,   601,   602,   603,   604,     0,     0,
       0,     0,     0,  1250,  1251,  1231,     0,   855,   855,  1234,
       0,  1236,   855,     0,  1260,     0,     0,   684,   685,   686,
       0,     0,     0,     0,     0,     0,  1248,     0,     0,   855,
     855,   497,     0,   687,     0,  1255,  1256,     0,     0,     0,
     855,     0,     0,     0,     0,     0,     0,   644,  1264,  1265,
    1266,   648,     0,  1269,  1270,     0,     0,   690,  1272,     0,
       0,     0,  1274,     0,     0,     0,     0,  1278,     0,     0,
       0,     0,     0,     0,   750,   751,   752,     0,     0,     0,
       0,   684,   685,   686,     0,     0,     0,     0,   754,   755,
       0,   756,   757,   758,   759,   497,     0,   718,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
       0,     0,     0,   564,   688,   565,     0,     0,     0,   689,
       0,   719,     0,   566,     0,     0,   567,     0,   568,   569,
     684,   685,   686,     0,   796,     0,   570,     0,   800,     0,
       0,     0,     0,     0,   497,     0,   718,   804,     0,     0,
       0,   684,   685,   686,     0,     0,   571,   572,   573,   574,
     577,     0,     0,   688,     0,   497,     0,   687,   689,     0,
     719,     0,     0,     0,     0,    54,    55,     0,     0,     0,
       0,     0,     0,     0,   688,     0,     0,     0,     0,   689,
       0,   690,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319
};

static const yytype_int16 yycheck[] =
{
       4,   394,     6,   329,   447,   331,    10,   333,   334,   335,
      14,   760,   338,   630,   631,   464,   555,   557,   835,   557,
     668,   669,     3,     4,   563,   545,   546,   547,   695,   545,
     546,   432,     3,     4,     5,   555,   556,     3,     4,   840,
     556,     3,     4,   563,     6,   557,   558,     7,     8,   398,
     399,   793,   401,   720,   403,   404,     3,     4,     5,     0,
     341,   342,    66,   347,     7,     8,   987,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,   347,
       3,     4,     5,    26,    27,   478,   347,   333,   345,   333,
     832,   833,   841,   842,   843,   345,   845,   846,   847,   848,
     849,   850,   359,     3,  1045,   351,     7,   351,   501,   359,
     630,   631,     7,   780,   630,   631,     3,     4,   347,   345,
       7,   311,   312,   313,   314,    26,   347,    28,    29,    30,
      31,    32,   881,   359,   880,   461,   537,     7,     8,   888,
     347,   887,   535,   347,     3,     4,   346,   473,     3,     4,
     307,   308,   545,   546,     7,   305,   306,   695,     3,     4,
       3,     4,  1012,   780,   981,     7,  1016,  1017,    21,    22,
      23,    24,    25,    26,   694,   309,   310,     7,  1028,   460,
     720,     7,   720,  1104,  1105,   986,   937,   936,   337,   338,
     339,     8,   518,   519,     8,   521,   522,     7,     7,     8,
       7,   392,   393,   529,   395,   396,   532,   949,     7,   400,
     877,   350,    21,    22,    23,    24,    25,    26,    27,     3,
       4,     5,     7,   616,  1145,   346,   361,   347,   554,   741,
     365,   879,   880,   368,   369,   348,   562,   630,   631,   887,
     348,   983,   780,   994,   995,   996,   997,     7,   359,   360,
     898,   899,   348,   579,   580,  1196,  1197,   905,   906,   999,
    1000,    21,    22,    23,    24,    25,   326,   327,   328,   618,
     348,   597,   348,   793,   623,   624,   625,   348,  1027,   628,
     802,   803,  1099,    45,    46,    47,    48,    49,    50,    51,
      52,   830,   831,   742,   687,   835,   577,   835,  1196,  1197,
     348,  1102,   348,   629,   353,   332,   632,   633,   634,   353,
     830,   831,   832,   833,   331,   353,     3,     4,  1069,  1169,
       7,     8,   834,   835,   353,   718,     7,   839,   840,    28,
      29,    30,    31,    32,    21,    22,    23,    24,    25,    26,
      27,   353,   353,   353,   325,   353,    33,    34,    35,    36,
     353,   353,   353,   353,   866,   353,   353,    44,   329,   330,
     353,   804,   346,     8,   345,     6,     6,   760,     6,   352,
     763,   331,   332,   333,   345,   334,   334,   381,   346,   345,
     335,   347,   346,   345,   335,   366,   335,   780,   331,   332,
     333,  1140,  1141,   335,   361,     7,   789,   335,   345,   353,
     353,  1143,   346,   353,   360,   371,   346,   346,   360,   802,
     803,   346,   346,   806,   807,   346,    28,    29,    30,    31,
      32,   364,   345,   353,   346,   346,   369,   347,   821,   949,
     331,   332,   333,   346,   827,  1083,   331,   332,   333,   353,
     979,   981,   982,   981,   331,   332,   333,   346,   841,   842,
     843,   348,   845,   846,   847,   848,   849,   850,   345,   979,
     980,   347,   347,   983,   980,   858,   859,   349,   369,   981,
     333,   346,   984,   985,   346,   987,   364,   481,   331,   332,
     333,   340,   341,   342,   343,   344,   345,   332,   881,   882,
     345,   365,   346,  1033,   346,   888,   346,  1009,  1010,   361,
     345,   331,   332,   333,   361,   331,   332,   333,   356,   365,
     331,   837,   331,   862,   863,     7,   369,   347,   362,   346,
    1032,   353,   331,   332,   333,   364,  1143,  1175,   364,    21,
      22,    23,    24,    25,    21,    22,    23,    24,    25,   865,
     353,   867,   353,   936,   346,   938,     6,     6,   346,  1061,
    1062,   346,   346,  1093,   362,   364,   346,   950,   362,  1099,
     369,  1099,   322,   323,   957,   315,   316,   317,   318,   319,
     320,   331,   332,   333,   967,   362,   362,   346,   971,   362,
     362,   346,   362,   362,  1124,   353,   360,  1099,   360,  1129,
    1102,  1103,  1104,  1105,   360,   347,     7,     8,   991,   360,
     346,   346,   346,   929,     7,   346,   645,   611,  1120,  1121,
      21,    22,    23,    24,    25,  1008,   346,   346,    21,    22,
      23,    24,    25,  1143,   348,   346,   346,  1167,   353,   346,
    1170,  1171,  1172,  1145,  1027,   961,  1176,  1177,  1178,  1179,
    1180,   353,  1182,   353,   331,   332,   333,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   695,   353,   345,   353,
     347,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   353,   353,  1001,   353,   364,   353,   325,
     346,   720,   369,   367,   371,  1011,   349,   349,  1200,  1201,
     729,  1084,   346,   346,   333,   346,   346,   361,   346,   346,
     311,  1241,   313,   361,  1097,   365,   365,   336,   365,  1035,
     321,   353,   356,   324,   370,   326,   327,   353,  1111,   331,
     332,   333,   331,   334,   763,   331,   348,     0,  1054,  1055,
    1056,   348,   348,     6,  1060,   370,   331,  1063,   348,  1132,
     331,   780,   361,   354,   355,   356,   357,  1140,  1141,   348,
    1143,   353,   353,   792,   346,   794,   795,   353,     6,   362,
     799,   359,  1155,   363,  1157,  1158,  1159,  1160,   362,   362,
     359,   346,    45,    46,    47,    48,    49,    50,    51,    52,
       3,     4,   362,   362,     7,     8,   363,   363,   362,   353,
     363,  1117,   363,   348,   348,   348,  1122,   346,    21,    22,
      23,    24,    25,    26,    27,   346,  1199,   346,   346,   346,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,   346,  1216,  1217,   346,   346,   346,  1221,   362,
     353,   323,   346,   348,   346,  1228,   353,   353,   877,   331,
     332,   333,   353,   882,   353,  1238,  1239,   353,   353,   348,
    1243,   349,   346,   857,   361,   346,  1249,   346,   346,     3,
       4,   363,   363,     7,     8,   346,   363,   363,  1261,   346,
     346,   323,   365,   938,   346,   370,   346,    21,    22,    23,
      24,    25,   361,   361,  1277,   370,   370,   370,   361,    33,
      34,    35,    36,   364,   363,   353,   353,   361,   346,   938,
      44,   346,   346,   346,   346,   346,   362,   346,   363,   948,
     359,   346,   346,   952,   953,   346,   363,   956,   957,   324,
     331,   332,   333,     3,     4,   964,   991,     7,   331,   332,
     333,   970,   361,   346,   362,   362,   346,   346,   346,   363,
     346,    21,    22,    23,    24,    25,    26,    27,   362,   346,
     332,   363,   991,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,   363,   360,   363,   361,   346,
     346,   346,     3,     4,   362,   347,     7,     8,   346,   346,
    1019,  1020,   346,   346,   346,   346,   346,   346,     6,   346,
     346,   346,   346,     3,     4,    26,    27,     7,     8,   348,
     346,  1005,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,   346,   362,    26,    27,   346,  1084,
     360,   294,   295,    33,    34,    35,    36,   346,   363,   346,
     361,   365,  1097,   363,    44,   349,   363,   346,   346,   360,
     346,   346,  1081,   363,   362,  1084,  1111,   362,  1087,  1088,
     363,   346,   346,  1092,   350,   351,   360,     6,  1097,   360,
     363,   357,   358,   346,   346,   346,   362,   363,   364,   365,
     346,   346,  1111,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   360,   346,   424,   425,  1125,   427,   428,   429,
    1155,   346,  1157,  1158,  1159,  1160,    45,    46,    47,    48,
      49,    50,    51,    52,   363,   363,   346,     6,   331,   332,
     333,   346,   346,   346,     6,  1154,  1155,   349,  1157,  1158,
    1159,  1160,   345,   349,   347,   346,   422,   346,   346,   346,
     426,   346,   346,    17,    56,    58,   840,   840,   613,   546,
     620,   364,  1103,   875,   949,   631,   369,   446,   371,   379,
     719,  1216,  1217,   821,   558,   578,  1221,   467,   468,    -1,
     470,   471,   472,    -1,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,    -1,  1238,  1239,  1214,    -1,  1216,  1217,  1218,
      -1,  1220,  1221,    -1,  1249,    -1,    -1,   331,   332,   333,
      -1,    -1,    -1,    -1,    -1,    -1,  1235,    -1,    -1,  1238,
    1239,   345,    -1,   347,    -1,  1244,  1245,    -1,    -1,    -1,
    1249,    -1,    -1,    -1,    -1,    -1,    -1,   527,  1257,  1258,
    1259,   531,    -1,  1262,  1263,    -1,    -1,   371,  1267,    -1,
      -1,    -1,  1271,    -1,    -1,    -1,    -1,  1276,    -1,    -1,
      -1,    -1,    -1,    -1,   584,   585,   586,    -1,    -1,    -1,
      -1,   331,   332,   333,    -1,    -1,    -1,    -1,   598,   599,
      -1,   601,   602,   603,   604,   345,    -1,   347,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,   311,   364,   313,    -1,    -1,    -1,   369,
      -1,   371,    -1,   321,    -1,    -1,   324,    -1,   326,   327,
     331,   332,   333,    -1,   644,    -1,   334,    -1,   648,    -1,
      -1,    -1,    -1,    -1,   345,    -1,   347,   657,    -1,    -1,
      -1,   331,   332,   333,    -1,    -1,   354,   355,   356,   357,
     358,    -1,    -1,   364,    -1,   345,    -1,   347,   369,    -1,
     371,    -1,    -1,    -1,    -1,   294,   295,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   364,    -1,    -1,    -1,    -1,   369,
      -1,   371,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   373,   374,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   375,   376,   378,   379,
     383,   385,   386,   387,   388,   389,   390,   391,   392,   393,
       3,     4,     5,   345,   377,   347,   377,   347,   347,   347,
     377,   347,   347,   347,   377,     6,    45,    46,    47,    48,
      49,    50,    51,    52,   294,   295,   394,   395,   396,   397,
     398,   534,   537,   538,   375,     3,   346,     8,   384,     7,
       7,     8,     8,     7,     7,     7,   350,     7,   395,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     402,   417,   419,   422,   424,   426,   428,   430,   432,   433,
     434,   435,   437,   440,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   458,   469,   478,   484,   486,   488,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     502,   503,   507,   508,   509,   510,   511,   512,   514,   516,
     520,   522,   523,   526,   529,   532,   397,   346,   535,   536,
     377,   348,   347,   382,   348,   348,   348,   348,   348,   348,
     348,   403,   404,   405,   353,   407,   408,   409,   410,   411,
     412,   413,   353,   414,   415,   353,   332,   331,   353,   353,
     353,   353,   353,   470,   471,   472,   474,   473,   479,   480,
     482,   481,   485,   489,   475,   483,   487,   476,   517,   518,
     521,   527,   528,   533,     7,    26,    28,    29,    30,    31,
      32,   331,   332,   333,   369,   540,   542,   543,   544,   558,
     544,   353,   544,   544,   544,   544,   353,   438,   544,   353,
     450,   451,   353,   451,   451,   353,   459,   459,   459,   353,
     461,   459,   459,   461,   459,   459,   459,   459,   353,     7,
     535,   346,   377,     8,   377,   380,   381,     6,     6,     6,
     333,   351,   399,   399,   399,     3,     4,   345,   564,   399,
     399,   352,   401,   401,   401,   399,   401,   334,   401,   401,
     334,   346,   346,   335,   335,   335,   335,   335,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   459,   361,   461,
     461,   459,   461,   461,   461,   353,   353,   524,   525,   525,
     353,   360,   360,   543,   540,   346,   346,   346,   315,   316,
     317,   318,   319,   320,   436,   346,   346,   346,   346,   307,
     308,   353,   439,   346,   311,   313,   321,   324,   326,   327,
     334,   354,   355,   356,   357,   451,   544,   358,   347,   454,
     454,   305,   306,   353,   460,   460,   460,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   566,   460,   460,   460,
     544,   460,   460,   460,   460,   325,   366,   465,   513,   564,
     377,   346,   348,   346,   347,   347,   349,   333,   346,   346,
     346,     3,     4,   406,   346,   346,     6,   564,   416,   420,
     423,   425,   427,   429,   431,   544,   544,   364,   544,   544,
     361,   361,   365,   356,   460,   362,   544,   365,   460,   544,
     364,   364,   340,   341,   342,   343,   344,   519,   564,   361,
     365,   368,   369,   525,   337,   338,   339,   531,   331,   331,
       7,     8,    21,    22,    23,    24,    25,    26,    27,    33,
      34,    35,    36,    44,   331,   332,   333,   347,   364,   369,
     371,   418,   539,   541,   545,   546,   547,   549,   550,   551,
     557,   559,   560,   561,   564,   418,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,   347,   371,
     546,   551,   552,   562,   563,   564,   544,   552,   551,   546,
     547,   553,   560,   562,   547,   548,   557,   309,   310,   544,
     552,   346,   451,   566,   544,   544,   311,   312,   313,   314,
     461,   461,   461,   544,   461,   461,   461,   461,   461,   461,
     353,   353,   353,   346,   377,   381,     6,     6,   564,   401,
     333,   351,   400,   400,   401,   401,   401,   401,   544,   421,
     546,   551,   561,   421,   544,   544,   544,   346,   346,   362,
     346,   346,   362,   362,   362,   362,   461,   539,   346,   362,
     461,   346,   362,   362,   461,   353,   345,   359,   554,   555,
     555,   360,   360,     5,   329,   330,   345,   564,   565,   360,
     360,   347,   546,   539,   541,   560,   564,   347,   563,   562,
     346,   346,   346,   346,   346,   346,   547,   454,   348,   346,
     346,   353,   353,   353,   346,   353,   353,   353,   353,   353,
     353,   465,   325,   367,   506,   539,   564,   346,   349,   349,
     346,   333,   346,   346,   561,   346,   346,   346,   361,   361,
     332,   515,   564,   365,   356,   539,   468,   546,   550,   539,
     539,   353,   359,   462,   463,   555,   365,   539,   353,   365,
     515,   515,   540,   336,   564,   564,   370,   370,   331,   331,
     348,   348,     5,   348,   348,   331,   331,   564,   565,   348,
     564,   552,   552,   550,   550,   547,   553,   544,   547,   322,
     323,   452,   453,   456,   547,   465,   465,   465,   361,   465,
     465,   465,   465,   465,   465,   353,   353,   353,   346,   377,
     564,   564,     6,   401,   401,   544,   547,   544,   362,   362,
     359,   363,   362,   362,   462,   363,   359,   359,   464,   555,
     464,   465,   539,   363,   362,   464,   465,   362,   363,   363,
     346,   353,   555,   555,   555,   555,   348,   348,   348,   346,
     346,   346,   346,   346,   346,   346,   346,   346,   353,   353,
     353,   362,   544,   501,   353,   353,   353,   353,   326,   327,
     328,   505,   465,   505,   506,   346,   348,   348,   349,   346,
     346,   346,   539,   468,   564,   346,   539,   539,   363,   346,
     347,   467,   539,   539,   363,   363,   544,   346,   539,   363,
     361,   564,   346,   346,   539,   564,   370,   370,   370,   370,
     552,   551,   553,   562,   550,   547,   452,   453,   456,   457,
     547,   453,   457,   547,   365,   361,   361,   506,   346,   361,
     505,   505,   505,   505,   353,   504,   504,   504,   544,   353,
     364,   377,   564,   547,   547,   544,   463,   363,   361,   463,
     463,   346,   539,   539,   359,   360,   466,   346,   346,   346,
     465,   463,   346,   362,   363,   547,   562,   346,   544,   346,
     554,   556,   346,   346,   346,   346,   544,   544,   544,   363,
     361,   362,   544,   547,   547,   544,   324,   505,   362,   346,
     346,   346,   346,   363,   346,   362,   363,   363,   539,   346,
     555,   506,   360,   539,   539,   361,   363,   539,   562,   477,
     346,   346,   506,   346,   553,   346,   455,   547,   455,   457,
     547,   457,   346,   346,   346,   362,   506,   346,   346,   346,
     346,   544,   332,     6,   547,   547,   544,   346,   562,   539,
     346,   346,   346,   562,   348,   564,   346,   346,   362,   346,
     346,   363,   346,   465,   465,   530,   550,   561,   457,   365,
     361,   539,   506,   363,   506,   506,   506,   506,   363,   349,
     346,   346,   562,   463,   562,   562,   562,   360,   555,   562,
     562,   562,   562,   562,   346,   562,   362,   362,   346,   363,
     346,   346,   556,   556,   564,   547,   547,   363,   360,   360,
     363,   539,   506,   506,   539,   346,   539,   506,   346,   346,
     346,   346,   564,   360,   346,   346,   363,   363,   539,   346,
     506,   506,     6,   562,   564,   539,   539,   346,   346,   346,
     506,   349,   346,   346,   539,   539,   539,   346,   564,   539,
     539,   346,   539,   346,   539,     6,   346,   349,   539,   564
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   372,   374,   373,   375,   375,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   377,   377,
     377,   377,   378,   379,   380,   381,   381,   381,   382,   382,
     384,   383,   385,   386,   386,   387,   388,   389,   390,   391,
     392,   393,   394,   394,   394,   394,   394,   394,   394,   394,
     395,   395,   396,   396,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   398,   399,   399,   400,   400,
     401,   401,   402,   403,   402,   404,   402,   405,   402,   406,
     402,   407,   402,   408,   402,   409,   402,   410,   402,   411,
     402,   402,   412,   402,   402,   402,   402,   402,   402,   402,
     413,   402,   402,   402,   402,   402,   414,   402,   402,   415,
     402,   402,   402,   402,   402,   416,   402,   417,   417,   418,
     418,   420,   419,   421,   421,   421,   423,   422,   425,   424,
     427,   426,   429,   428,   431,   430,   432,   432,   432,   432,
     432,   432,   432,   432,   433,   433,   433,   433,   433,   433,
     433,   433,   433,   433,   433,   433,   433,   433,   434,   434,
     434,   434,   434,   434,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     435,   436,   436,   436,   436,   436,   436,   437,   437,   437,
     438,   438,   439,   439,   440,   440,   440,   440,   440,   440,
     440,   440,   440,   440,   440,   440,   440,   440,   440,   440,
     441,   441,   441,   441,   441,   442,   442,   443,   443,   444,
     444,   444,   444,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   446,   447,   447,   448,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   451,   451,
     452,   453,   454,   455,   456,   456,   456,   456,   457,   457,
     457,   458,   458,   458,   458,   458,   458,   458,   458,   458,
     459,   459,   460,   460,   460,   460,   461,   462,   463,   463,
     464,   464,   465,   466,   466,   467,   467,   468,   470,   469,
     471,   469,   472,   469,   473,   469,   474,   469,   475,   469,
     476,   477,   469,   479,   478,   480,   478,   481,   478,   482,
     478,   483,   478,   485,   484,   487,   486,   489,   488,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     491,   491,   491,   491,   491,   491,   491,   491,   491,   491,
     491,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     492,   492,   493,   494,   495,   496,   496,   496,   497,   498,
     499,   500,   500,   501,   500,   502,   502,   502,   503,   504,
     504,   505,   505,   505,   506,   506,   507,   508,   508,   508,
     508,   508,   508,   508,   508,   508,   508,   508,   509,   510,
     511,   511,   511,   511,   512,   513,   513,   513,   514,   515,
     515,   515,   517,   516,   518,   516,   519,   519,   519,   519,
     519,   519,   521,   520,   522,   522,   522,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     524,   524,   524,   524,   525,   525,   527,   526,   528,   526,
     529,   529,   529,   530,   530,   531,   531,   531,   532,   532,
     532,   532,   532,   532,   532,   533,   532,   534,   535,   535,
     536,   537,   538,   539,   539,   539,   539,   540,   540,   540,
     540,   541,   542,   542,   542,   542,   542,   543,   543,   544,
     544,   545,   545,   545,   545,   545,   546,   546,   547,   547,
     548,   548,   549,   549,   550,   550,   551,   551,   551,   552,
     552,   552,   553,   553,   553,   554,   554,   555,   555,   556,
     557,   557,   558,   558,   559,   559,   560,   560,   561,   561,
     561,   561,   561,   561,   561,   561,   561,   561,   561,   561,
     562,   562,   562,   562,   562,   563,   563,   563,   563,   563,
     563,   563,   563,   563,   563,   563,   563,   564,   564,   564,
     564,   565,   565,   566,   566,   566,   566,   566,   566,   566,
     566,   566
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     1,     1,     3,     0,     3,     0,
       0,     5,     4,     4,     4,     4,     2,     2,     1,    10,
      10,    23,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     2,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     2,     1,     0,     5,     0,     7,     0,     7,     0,
       5,     0,     5,     0,     5,     0,     3,     0,     3,     0,
       3,     1,     0,     3,     1,     1,     1,     1,     1,     1,
       0,     3,     1,     1,     1,     1,     0,     3,     1,     0,
       3,     1,     1,     1,     1,     0,     5,     3,     3,     1,
       1,     0,     5,     1,     1,     2,     0,     5,     0,     5,
       0,    11,     0,    13,     0,    13,     1,     1,     1,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     8,     6,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     8,
       8,     8,    10,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       1,     1,     3,     1,     1,     3,     1,     1,     1,     3,
       3,     5,    10,     8,     6,     4,    10,     8,    11,     1,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       1,     2,     1,     7,     2,     7,     2,     3,     0,    12,
       0,    11,     0,    15,     0,    12,     0,    12,     0,    12,
       0,     0,    12,     0,    12,     0,    11,     0,    12,     0,
      12,     0,    12,     0,    17,     0,    17,     0,     9,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,    20,    13,    16,     1,     1,     1,     1,     1,
       1,     9,    16,     0,    17,     1,     1,     1,     3,     0,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
      11,    13,    14,    14,     1,     6,     8,     9,     7,     1,
       1,     3,     0,    11,     0,    11,     1,     1,     1,     1,
       1,     1,     0,    10,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     0,     2,     0,     3,     0,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,    11,     1,     1,     2,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     0,     2,     1,     2,     1,
       5,     5,     5,     5,     5,     5,     1,     1,     1,     3,
       3,     4,     4,     3,     3,     1,     1,     1,     1,     1,
       1,     3,     1,     4,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 748 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3259 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 766 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3265 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 767 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3271 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 768 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3277 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 769 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3283 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 771 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3293 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 777 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3301 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_init_val: const_val  */
#line 781 "../src/freedreno/ir3/ir3_parser.y"
                                { add_buf_init_val((yyvsp[0].unum)); }
#line 3307 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 787 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3320 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* $@2: %empty  */
#line 797 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 803 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 809 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 816 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3363 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 823 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 832 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 834 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 836 "../src/freedreno/ir3/ir3_parser.y"
                                        { variant->early_preamble = 1; }
#line 3394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_SY  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_SS  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_JP  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 45: /* iflag: T_EQ_FLAG  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                             { iflags.flags |= IR3_INSTR_EQ; }
#line 3436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 46: /* iflag: T_SAT  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 47: /* iflag: T_RPT  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 48: /* iflag: T_UL  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 49: /* iflag: T_NOP  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 59: /* instr: iflags cat5_instr  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* label: T_IDENTIFIER ':'  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_src1: '!' T_P0  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* cat0_src1: T_P0  */
#line 880 "../src/freedreno/ir3/ir3_parser.y"
                                   { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* cat0_src2: '!' T_P0  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* cat0_src2: T_P0  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                   { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 70: /* cat0_immed: '#' integer  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* cat0_immed: '#' T_IDENTIFIER  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 72: /* cat0_instr: T_OP_NOP  */
#line 888 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@3: %empty  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BR);   }
#line 3520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@4: %empty  */
#line 890 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAO); }
#line 3526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@5: %empty  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAA); }
#line 3532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* $@6: %empty  */
#line 892 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_BRAC)->cat0.idx = (yyvsp[0].num); }
#line 3538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* $@7: %empty  */
#line 893 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BANY); }
#line 3544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@8: %empty  */
#line 894 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BALL); }
#line 3550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* $@9: %empty  */
#line 895 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAX); }
#line 3556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* $@10: %empty  */
#line 896 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* $@11: %empty  */
#line 897 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_RET  */
#line 898 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* $@12: %empty  */
#line 899 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* cat0_instr: T_OP_END  */
#line 900 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* cat0_instr: T_OP_EMIT  */
#line 901 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_CUT  */
#line 902 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* cat0_instr: T_OP_CHMASK  */
#line 903 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_CHSH  */
#line 904 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_FLOW_REV  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* $@13: %empty  */
#line 906 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* cat0_instr: T_OP_STKS  */
#line 907 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* cat0_instr: T_OP_STKR  */
#line 908 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* cat0_instr: T_OP_XSET  */
#line 909 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* cat0_instr: T_OP_XCLR  */
#line 910 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* $@14: %empty  */
#line 911 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* cat0_instr: T_OP_DBG  */
#line 912 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 109: /* $@15: %empty  */
#line 913 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 111: /* cat0_instr: T_OP_SHPE  */
#line 914 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* cat0_instr: T_OP_PREDT  */
#line 915 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* cat0_instr: T_OP_PREDF  */
#line 916 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* cat0_instr: T_OP_PREDE  */
#line 917 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* $@16: %empty  */
#line 918 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 117: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 920 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3702 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3710 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* $@17: %empty  */
#line 930 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3720 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 122: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@17 dst_reg  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 126: /* $@18: %empty  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3747 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 128: /* $@19: %empty  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3758 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 130: /* $@20: %empty  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3764 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 132: /* $@21: %empty  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3770 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 134: /* $@22: %empty  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3776 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3782 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3788 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3794 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3800 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 984 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3806 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 985 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3812 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 986 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3818 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 987 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3824 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 988 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3830 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3836 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_1src: T_OP_NOT_B  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3842 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 991 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3848 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_1src: T_OP_SETRM  */
#line 992 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3854 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 993 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3860 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3866 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3872 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3878 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3884 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3890 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3896 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_ADD_F  */
#line 1002 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3902 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_MIN_F  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3908 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_MAX_F  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3914 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MUL_F  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3920 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_ADD_U  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3926 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_ADD_S  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_SUB_U  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3938 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_SUB_S  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_MIN_U  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3950 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_MIN_S  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3956 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MAX_U  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3962 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_MAX_S  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3968 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_AND_B  */
#line 1014 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3974 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_OR_B  */
#line 1015 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3980 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_XOR_B  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3986 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3992 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 1018 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3998 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_MULL_U  */
#line 1019 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 4004 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_SHL_B  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 4010 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_SHR_B  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 4016 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 4022 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat2_opc_2src: T_OP_BARY_F  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 4028 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 4034 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 4040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 4046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cat2_opc_2src: T_OP_SHB  */
#line 1027 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 4052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cat2_opc_2src: T_OP_MSAD  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 4058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cond: T_LT  */
#line 1030 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 4064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 192: /* cond: T_LE  */
#line 1031 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 4070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cond: T_GT  */
#line 1032 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 4076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cond: T_GE  */
#line 1033 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 4082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cond: T_EQ  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 4088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cond: T_NE  */
#line 1035 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 4094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_dp_signedness: '.' T_MIXED  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 4100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 4106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_dp_pack: '.' T_LOW  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 4112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_dp_pack: '.' T_HIGH  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 4118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_U16  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 4124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_MADSH_U16  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 4130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_MAD_S16  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 4136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_MADSH_M16  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 4142 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_MAD_U24  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4148 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_MAD_S24  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_MAD_F16  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4160 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_MAD_F32  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SEL_B16  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4172 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_opc: T_OP_SEL_B32  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4178 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_opc: T_OP_SEL_S16  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4184 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_opc: T_OP_SEL_S32  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_opc: T_OP_SEL_F16  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4196 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_opc: T_OP_SEL_F32  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_opc: T_OP_SAD_S16  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_opc: T_OP_SAD_S32  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 224: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 225: /* cat3_wmm: T_OP_WMM  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat3_dp: T_OP_DP2ACC  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat3_dp: T_OP_DP4ACC  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4268 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_RCP  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_RSQ  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_LOG2  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat4_opc: T_OP_EXP2  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat4_opc: T_OP_SIN  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat4_opc: T_OP_COS  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat4_opc: T_OP_SQRT  */
#line 1087 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat4_opc: T_OP_HRSQ  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat4_opc: T_OP_HLOG2  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat4_opc: T_OP_HEXP2  */
#line 1090 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc_isam: T_OP_ISAM  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM)->flags |= IR3_INSTR_INV_1D; }
#line 4346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_ISAML  */
#line 1099 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_ISAMM  */
#line 1100 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_SAM  */
#line 1101 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_SAMB  */
#line 1102 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_SAML  */
#line 1103 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_SAMGQ  */
#line 1104 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_GETLOD  */
#line 1105 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_CONV  */
#line 1106 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_CONVM  */
#line 1107 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_GETSIZE  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GETBUF  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GETPOS  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_GETINFO  */
#line 1111 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_DSX  */
#line 1112 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_DSY  */
#line 1113 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_GATHER4R  */
#line 1114 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_GATHER4G  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_GATHER4B  */
#line 1116 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_GATHER4A  */
#line 1117 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_SAMGP0  */
#line 1118 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_SAMGP1  */
#line 1119 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_SAMGP2  */
#line 1120 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_SAMGP3  */
#line 1121 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_opc: T_OP_RGETPOS  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_opc: T_OP_RGETINFO  */
#line 1123 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_opc: T_OP_BRCST_A  */
#line 1124 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1125 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1126 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1127 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1128 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_3D  */
#line 1130 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' 'a'  */
#line 1131 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' 'o'  */
#line 1132 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat5_flag: '.' 'p'  */
#line 1133 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat5_flag: '.' 's'  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* cat5_flag: '.' T_S2EN  */
#line 1135 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat5_flag: '.' T_1D  */
#line 1136 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags &= ~IR3_INSTR_INV_1D; }
#line 4568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_flag: '.' T_UNIFORM  */
#line 1137 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1138 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat5_flag: '.' T_BASE  */
#line 1139 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 287: /* cat5_flag: '.' T_W  */
#line 1140 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 290: /* cat5_samp: T_SAMP  */
#line 1144 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 291: /* cat5_tex: T_TEX  */
#line 1145 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 292: /* cat5_type: '(' type ')'  */
#line 1146 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 293: /* cat5_a1: src_reg  */
#line 1147 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat5_instr: cat5_opc_isam '.' 'v' cat5_flags cat5_type dst_reg ',' src_reg src_uoffset ',' cat5_samp_tex_all  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                    { instr->flags |= IR3_INSTR_V; }
#line 4622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat5_instr: T_OP_TCINV  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_typed: '.' T_UNTYPED  */
#line 1168 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 311: /* cat6_typed: '.' T_TYPED  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 312: /* cat6_dim: '.' T_1D  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_dim: '.' T_2D  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_dim: '.' T_3D  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 315: /* cat6_dim: '.' T_4D  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* cat6_type: '.' type  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_imm_offset: offset  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat6_dst_offset: offset  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_immed: integer  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4698 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* cat6_a6xx_global_address_pt3: '+' cat6_reg_or_immed  */
#line 1191 "../src/freedreno/ir3/ir3_parser.y"
                                         {
                        // Dummy src to smooth the difference between a6xx and a7xx
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                   }
#line 4707 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4717 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* $@23: %empty  */
#line 1208 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4723 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 330: /* $@24: %empty  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4729 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 332: /* $@25: %empty  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_K); }
#line 4735 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 334: /* $@26: %empty  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4741 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* $@27: %empty  */
#line 1212 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4747 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 338: /* $@28: %empty  */
#line 1213 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4753 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* $@29: %empty  */
#line 1214 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4759 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* $@30: %empty  */
#line 1214 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4767 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 343: /* $@31: %empty  */
#line 1218 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4773 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 345: /* $@32: %empty  */
#line 1219 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4779 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* $@33: %empty  */
#line 1220 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4785 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* $@34: %empty  */
#line 1221 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4791 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* $@35: %empty  */
#line 1222 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4797 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* $@36: %empty  */
#line 1224 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4803 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* $@37: %empty  */
#line 1225 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4809 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* $@38: %empty  */
#line 1227 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4815 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1229 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4821 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1230 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4827 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1231 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4833 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1232 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4839 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1233 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4845 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1234 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4851 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1235 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4857 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4863 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1237 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4869 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1238 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4875 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1239 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4881 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1241 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4887 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1242 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4893 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1243 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4899 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1244 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4905 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1245 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4911 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1246 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4917 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1247 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4923 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1248 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4929 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1249 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4935 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1250 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4941 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1251 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4947 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1253 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4953 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4959 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1255 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4965 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 384: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1256 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4971 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1257 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4977 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4983 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 387: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1259 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4989 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 388: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1260 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4995 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 389: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1261 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 5001 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 390: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1262 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 5007 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 5013 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1275 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 5019 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1277 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 5025 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1278 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 5031 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 403: /* $@39: %empty  */
#line 1282 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 5037 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* cat6_id_opc: T_OP_GETSPID  */
#line 1285 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 5043 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* cat6_id_opc: T_OP_GETWID  */
#line 1286 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 5049 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1287 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 5055 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_bindless_base: '.' T_BASE  */
#line 1292 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 5061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1296 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 5067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_reg_or_immed: integer  */
#line 1299 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5073 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1301 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 5079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1303 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 5085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1304 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 5091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1305 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 5097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1306 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 5103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1307 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 5109 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 422: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1308 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 5115 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1309 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 5121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1310 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 5127 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 425: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1311 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 5133 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1312 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 5139 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1313 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 5145 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* cat6_bindless_ibo_opc_3src: T_OP_STIB_B  */
#line 1315 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 5151 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* cat6_bindless_ibo_opc_3src_dst: T_OP_LDIB_B  */
#line 1317 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 5157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1320 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 5163 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_3src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed src_uoffset ',' cat6_reg_or_immed  */
#line 1321 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                                  { swap(instr->srcs[0], instr->srcs[3]); }
#line 5169 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_3src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed src_uoffset ',' cat6_reg_or_immed  */
#line 1322 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); swap(instr->srcs[1], instr->srcs[2]); }
#line 5175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1324 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1328 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5187 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* cat6_bindless_ldc_middle: 'u' '.' T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1329 "../src/freedreno/ir3/ir3_parser.y"
                                                                                       { instr->flags |= IR3_INSTR_U; instr->cat6.d = (yyvsp[-5].tok); }
#line 5193 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1330 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5199 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1332 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5209 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* const_dst: integer  */
#line 1338 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5215 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* const_dst: T_A1  */
#line 1339 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5221 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* const_dst: T_A1 '+' integer  */
#line 1340 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5227 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 442: /* $@40: %empty  */
#line 1343 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5233 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 444: /* $@41: %empty  */
#line 1344 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5239 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 446: /* cat6_shfl_mode: T_MOD_XOR  */
#line 1346 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_XOR;   }
#line 5245 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 447: /* cat6_shfl_mode: T_MOD_UP  */
#line 1347 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_UP;    }
#line 5251 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 448: /* cat6_shfl_mode: T_MOD_DOWN  */
#line 1348 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_DOWN;  }
#line 5257 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 449: /* cat6_shfl_mode: T_MOD_RUP  */
#line 1349 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_RUP;   }
#line 5263 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 450: /* cat6_shfl_mode: T_MOD_RDOWN  */
#line 1350 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_RDOWN; }
#line 5269 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 451: /* cat6_shfl_mode: integer  */
#line 1354 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = (yyvsp[0].num); }
#line 5275 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 452: /* $@42: %empty  */
#line 1357 "../src/freedreno/ir3/ir3_parser.y"
                   { new_instr(OPC_SHFL); }
#line 5281 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 454: /* cat6_todo: T_OP_G2L  */
#line 1360 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5287 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 455: /* cat6_todo: T_OP_L2G  */
#line 1361 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5293 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 456: /* cat6_todo: T_OP_RESFMT  */
#line 1362 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5299 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* cat7_scope: '.' 'w'  */
#line 1378 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5305 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* cat7_scope: '.' 'r'  */
#line 1379 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5311 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* cat7_scope: '.' 'l'  */
#line 1380 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5317 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* cat7_scope: '.' 'g'  */
#line 1381 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5323 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* $@43: %empty  */
#line 1386 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5329 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* $@44: %empty  */
#line 1387 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5335 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* cat7_data_cache: T_OP_DCCLN  */
#line 1389 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5341 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* cat7_data_cache: T_OP_DCINV  */
#line 1390 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5347 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* cat7_data_cache: T_OP_DCFLU  */
#line 1391 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5353 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 485: /* cat7_alias_scope: T_MOD_TEX  */
#line 1396 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5359 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 486: /* cat7_alias_scope: T_MOD_MEM  */
#line 1397 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5365 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* cat7_alias_scope: T_MOD_RT  */
#line 1398 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5371 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 490: /* cat7_instr: T_OP_SLEEP  */
#line 1402 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5377 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 491: /* cat7_instr: T_OP_CCINV  */
#line 1403 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_CCINV); }
#line 5383 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 492: /* cat7_instr: T_OP_ICINV  */
#line 1404 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5389 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 493: /* cat7_instr: T_OP_LOCK  */
#line 1405 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5395 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 494: /* cat7_instr: T_OP_UNLOCK  */
#line 1406 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5401 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 495: /* $@45: %empty  */
#line 1407 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5410 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* cat7_instr: T_OP_ALIAS $@45 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1410 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 497: /* raw_instr: T_RAW  */
#line 1414 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 500: /* meta_print_reg: ',' T_REGISTER  */
#line 1419 "../src/freedreno/ir3/ir3_parser.y"
                               {
	meta_print_data.regs_to_dump[meta_print_data.regs_count++] = (yyvsp[0].num);
}
#line 5432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 501: /* meta_print_start: T_OP_PRINT T_REGISTER  */
#line 1423 "../src/freedreno/ir3/ir3_parser.y"
                                        {
	meta_print_data.reg_address_lo = (yyvsp[0].num);
	meta_print_data.reg_address_hi = (yyvsp[0].num) + 2;
	meta_print_data.reg_tmp = (yyvsp[0].num) + 4;
	meta_print_data.regs_count = 0;
}
#line 5443 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 502: /* meta_print: meta_print_start meta_print_regs  */
#line 1430 "../src/freedreno/ir3/ir3_parser.y"
                                             {
	/* low */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova & 0xffffffff;

	/* high */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_hi, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova >> 32;

	/* offset */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_tmp, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = 4 * meta_print_data.regs_count;

	new_instr(OPC_NOP);
	instr->repeat = 5;

	/* Increment and get current offset into print buffer */
	new_instr(OPC_ATOMIC_G_ADD);
	instr->cat6.d = 1;
	instr->cat6.typed = 0;
	instr->cat6.type = TYPE_U32;
	instr->cat6.iim_val = 1;

	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_tmp, 0);

	/* Store all regs */
	for (uint32_t i = 0; i < meta_print_data.regs_count; i++) {
		new_instr(OPC_STG);
		dummy_dst();
		instr->cat6.type = TYPE_U32;
		instr->flags = IR3_INSTR_SY;
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->iim_val = 0;
		new_src(meta_print_data.regs_to_dump[i], IR3_REG_R);
		new_src(0, IR3_REG_IMMED)->iim_val = 1;

		new_instr(OPC_ADD_U);
		instr->flags = IR3_INSTR_SS;
		new_dst(meta_print_data.reg_address_lo, 0);
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->uim_val = 4;

		new_instr(OPC_NOP);
		instr->repeat = 5;
	}
}
#line 5505 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 503: /* src: T_REGISTER  */
#line 1488 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5511 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 504: /* src: T_A0  */
#line 1489 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5517 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 505: /* src: T_A1  */
#line 1490 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5523 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 506: /* src: T_P0  */
#line 1491 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 5529 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 507: /* dst: T_REGISTER  */
#line 1493 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5535 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 508: /* dst: T_A0  */
#line 1494 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5541 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 509: /* dst: T_A1  */
#line 1495 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5547 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 510: /* dst: T_P0  */
#line 1496 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 5553 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 511: /* const: T_CONSTANT  */
#line 1498 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5559 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 512: /* dst_reg_flag: T_EVEN  */
#line 1500 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5565 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 513: /* dst_reg_flag: T_POS_INFINITY  */
#line 1501 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5571 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 514: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1502 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 515: /* dst_reg_flag: T_EI  */
#line 1503 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5583 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 516: /* dst_reg_flag: T_WRMASK  */
#line 1504 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5589 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 519: /* dst_reg: dst  */
#line 1510 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5595 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 520: /* dst_reg: dst_reg_flags dst  */
#line 1511 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5601 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 521: /* src_reg_flag: T_ABSNEG  */
#line 1513 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5607 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 522: /* src_reg_flag: T_NEG  */
#line 1514 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5613 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 523: /* src_reg_flag: T_ABS  */
#line 1515 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5619 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 524: /* src_reg_flag: T_R  */
#line 1516 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 525: /* src_reg_flag: T_LAST  */
#line 1517 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 545: /* uoffset: %empty  */
#line 1546 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 546: /* uoffset: '+' integer  */
#line 1547 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 548: /* offset: '-' integer  */
#line 1550 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 549: /* src_uoffset: uoffset  */
#line 1552 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); if ((yyvsp[0].num)) instr->flags |= IR3_INSTR_IMM_OFFSET; }
#line 5655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 550: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1554 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 551: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1555 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5667 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 552: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1557 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5673 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 553: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1558 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5679 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 554: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1560 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5685 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 555: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1561 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 558: /* immediate_cat1: integer  */
#line 1573 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5697 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 559: /* immediate_cat1: '(' integer ')'  */
#line 1574 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5703 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 560: /* immediate_cat1: '(' float ')'  */
#line 1575 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5709 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 561: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1576 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5715 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 562: /* immediate_cat1: 'h' '(' float ')'  */
#line 1577 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5721 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 563: /* immediate_cat1: '(' T_NAN ')'  */
#line 1578 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5727 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 564: /* immediate_cat1: '(' T_INF ')'  */
#line 1579 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5733 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 565: /* immediate_cat1: T_FLUT_0_0  */
#line 1580 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 0.0; }
#line 5739 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 566: /* immediate_cat1: T_FLUT_0_5  */
#line 1581 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 0.5; }
#line 5745 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 567: /* immediate_cat1: T_FLUT_1_0  */
#line 1582 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 1.0; }
#line 5751 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 568: /* immediate_cat1: T_FLUT_2_0  */
#line 1583 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 2.0; }
#line 5757 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 569: /* immediate_cat1: T_FLUT_4_0  */
#line 1584 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 4.0; }
#line 5763 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 570: /* immediate: integer  */
#line 1586 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5769 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 571: /* immediate: '(' integer ')'  */
#line 1587 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5775 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 572: /* immediate: flut_immed  */
#line 1588 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5781 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 573: /* immediate: 'h' '(' integer ')'  */
#line 1589 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5787 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 574: /* immediate: 'h' flut_immed  */
#line 1590 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5793 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 587: /* integer: T_INT  */
#line 1606 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5799 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 588: /* integer: '-' T_INT  */
#line 1607 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5805 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 589: /* integer: T_HEX  */
#line 1608 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5811 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 590: /* integer: '-' T_HEX  */
#line 1609 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5817 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 591: /* float: T_FLOAT  */
#line 1611 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5823 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 592: /* float: '-' T_FLOAT  */
#line 1612 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5829 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 593: /* type: T_TYPE_F16  */
#line 1614 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_F16;   }
#line 5835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 594: /* type: T_TYPE_F32  */
#line 1615 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_F32;   }
#line 5841 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 595: /* type: T_TYPE_U16  */
#line 1616 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U16;   }
#line 5847 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 596: /* type: T_TYPE_U32  */
#line 1617 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U32;   }
#line 5853 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 597: /* type: T_TYPE_S16  */
#line 1618 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_S16;   }
#line 5859 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 598: /* type: T_TYPE_S32  */
#line 1619 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_S32;   }
#line 5865 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 599: /* type: T_TYPE_U8  */
#line 1620 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U8;    }
#line 5871 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 600: /* type: T_TYPE_U8_32  */
#line 1621 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U8_32; }
#line 5877 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 601: /* type: T_TYPE_U64  */
#line 1622 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_ATOMIC_U64;  }
#line 5883 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5887 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

